<html>
<head>
<title>Ogre::RTShader::FunctionInvocation Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::FunctionInvocation Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::FunctionInvocation" --><!-- doxytag: inherits="Ogre::RTShader::FunctionAtom" -->
<p>A class that represents function invocation code from shader based program function.  
 <a href="classOgre_1_1RTShader_1_1FunctionInvocation.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::FunctionInvocation:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1FunctionInvocation__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1FunctionInvocation_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1FunctionInvocation_inherit__map" id="Ogre_1_1RTShader_1_1FunctionInvocation_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1RTShader_1_1FunctionAtom.html" title="A class that represents an atomic code section of shader based program function." alt="" coords="20,83,225,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="45,5,200,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1FunctionInvocation-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationCompare.html">FunctionInvocationCompare</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparator function to be used for comparisons.  <a href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationCompare.html#details">More...</a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">struct &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationLessThan.html">FunctionInvocationLessThan</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Comparator function to be used for sorting.  <a href="structOgre_1_1RTShader_1_1FunctionInvocation_1_1FunctionInvocationLessThan.html#details">More...</a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a></td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a34fb49292fea4d2b9b0915e7557b0f87">FunctionInvocation</a> (const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;functionName, int groupOrder, int internalOrder, <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> returnType=&quot;void&quot;)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#a34fb49292fea4d2b9b0915e7557b0f87"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ab5cef3873f219044a14d32f89e165750">FunctionInvocation</a> (const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy constructor.  <a href="#ab5cef3873f219044a14d32f89e165750"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a25b62528459748e9a24cfb730a48e043">writeSourceCode</a> (std::ostream &amp;os, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;targetLanguage) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a5d5fb412bf05e9c04d7a9084fdeef9c7">getFunctionAtomType</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a9e9e5dd69fd84e4c67b89605bc608f4e">getOperandList</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get a list of parameters this function invocation will use in the function call as arguments.  <a href="#a9e9e5dd69fd84e4c67b89605bc608f4e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#afc5bce23c96684eee4cba52bfe778d51">pushOperand</a> (<a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> parameter, <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">Operand::OpSemantic</a> opSemantic, int opMask=<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">Operand::OPM_ALL</a>, int indirectionLevel=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Push a new operand (on the end) to the function.  <a href="#afc5bce23c96684eee4cba52bfe778d51"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ac59d6c18ad1b47e6748b173ccd8c9d0f">getFunctionName</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the function name.  <a href="#ac59d6c18ad1b47e6748b173ccd8c9d0f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a7025e33c39fe3126043a769321118b36">getReturnType</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the return type.  <a href="#a7025e33c39fe3126043a769321118b36"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a39c8acbda74217791c7f4aa847c776f1">operator==</a> (const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;rhs) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines if the current object is equal to the compared one.  <a href="#a39c8acbda74217791c7f4aa847c776f1"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a1e48a2cb0e3f18ff3245ea12ee8542f0">operator!=</a> (const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;rhs) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines if the current object is not equal to the compared one.  <a href="#a1e48a2cb0e3f18ff3245ea12ee8542f0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a59d5e7a792b52124ccff625e133d3ccd">operator&lt;</a> (const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;rhs) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Determines if the current object is less than the compared one.  <a href="#a59d5e7a792b52124ccff625e133d3ccd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#ab061ac5ec329a636ee0977d0e7364ff5">getGroupExecutionOrder</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the group execution order of this function atom.  <a href="#ab061ac5ec329a636ee0977d0e7364ff5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a157f51d4427fab33143f7156be05ba60">getInternalExecutionOrder</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get an internal execution order within a group of this function atom.  <a href="#a157f51d4427fab33143f7156be05ba60"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#aaae61702cada22f742ffd7f26d56c723">Type</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The type of this class.  <a href="#aaae61702cada22f742ffd7f26d56c723"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a42c43ab09ddc59f82be80c525d38a3c6">mFunctionName</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ad7a2d9fefa8e5048587b2669b5254470">mReturnType</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#abcff7ec674637ae18bd18a890130f975">mOperands</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#ac336aaa5014552245bf7b1ce1fb6e761">mGroupExecutionOrder</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a452182d826bf64b754dbb220227e68a2">mInternalExecutionOrder</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A class that represents function invocation code from shader based program function. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00161">161</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a709fbe496a60e5c9568461c236b4fa26"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::OperandVector" ref="a709fbe496a60e5c9568461c236b4fa26" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a>&gt;::type <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">Ogre::RTShader::FunctionInvocation::OperandVector</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00165">165</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a34fb49292fea4d2b9b0915e7557b0f87"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::FunctionInvocation" ref="a34fb49292fea4d2b9b0915e7557b0f87" args="(const String &amp;functionName, int groupOrder, int internalOrder, String returnType=&quot;void&quot;)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a34fb49292fea4d2b9b0915e7557b0f87">Ogre::RTShader::FunctionInvocation::FunctionInvocation</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>functionName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>groupOrder</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>internalOrder</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td>
          <td class="paramname"><em>returnType</em> = <code>&quot;void&quot;</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">functionName</td><td>The name of the function to invoke. </td></tr>
    <tr><td class="paramname">groupOrder</td><td>The group order of this invocation. </td></tr>
    <tr><td class="paramname">internalOrder</td><td>The internal order of this invocation. </td></tr>
    <tr><td class="paramname">returnType</td><td>The return type of the used function. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ab5cef3873f219044a14d32f89e165750"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::FunctionInvocation" ref="ab5cef3873f219044a14d32f89e165750" args="(const FunctionInvocation &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a34fb49292fea4d2b9b0915e7557b0f87">Ogre::RTShader::FunctionInvocation::FunctionInvocation</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copy constructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a5d5fb412bf05e9c04d7a9084fdeef9c7"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::getFunctionAtomType" ref="a5d5fb412bf05e9c04d7a9084fdeef9c7" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a5d5fb412bf05e9c04d7a9084fdeef9c7">Ogre::RTShader::FunctionInvocation::getFunctionAtomType</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a3d278b9398be98d84922926b862871d0" title="Return the type of this atom instance implementation.">FunctionAtom::getFunctionAtomType</a> </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a3d278b9398be98d84922926b862871d0">Ogre::RTShader::FunctionAtom</a>.</p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00186">186</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac59d6c18ad1b47e6748b173ccd8c9d0f"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::getFunctionName" ref="ac59d6c18ad1b47e6748b173ccd8c9d0f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ac59d6c18ad1b47e6748b173ccd8c9d0f">Ogre::RTShader::FunctionInvocation::getFunctionName</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the function name. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00200">200</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab061ac5ec329a636ee0977d0e7364ff5"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::getGroupExecutionOrder" ref="ab061ac5ec329a636ee0977d0e7364ff5" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#ab061ac5ec329a636ee0977d0e7364ff5">Ogre::RTShader::FunctionAtom::getGroupExecutionOrder</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the group execution order of this function atom. </p>

</div>
</div>
<a class="anchor" id="a157f51d4427fab33143f7156be05ba60"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::getInternalExecutionOrder" ref="a157f51d4427fab33143f7156be05ba60" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a157f51d4427fab33143f7156be05ba60">Ogre::RTShader::FunctionAtom::getInternalExecutionOrder</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get an internal execution order within a group of this function atom. </p>

</div>
</div>
<a class="anchor" id="a9e9e5dd69fd84e4c67b89605bc608f4e"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::getOperandList" ref="a9e9e5dd69fd84e4c67b89605bc608f4e" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a9e9e5dd69fd84e4c67b89605bc608f4e">Ogre::RTShader::FunctionInvocation::getOperandList</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get a list of parameters this function invocation will use in the function call as arguments. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00189">189</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7025e33c39fe3126043a769321118b36"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::getReturnType" ref="a7025e33c39fe3126043a769321118b36" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a7025e33c39fe3126043a769321118b36">Ogre::RTShader::FunctionInvocation::getReturnType</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the return type. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00203">203</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1e48a2cb0e3f18ff3245ea12ee8542f0"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator!=" ref="a1e48a2cb0e3f18ff3245ea12ee8542f0" args="(const FunctionInvocation &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::RTShader::FunctionInvocation::operator!= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Determines if the current object is not equal to the compared one. </p>

</div>
</div>
<a class="anchor" id="a59d5e7a792b52124ccff625e133d3ccd"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator&lt;" ref="a59d5e7a792b52124ccff625e133d3ccd" args="(const FunctionInvocation &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::RTShader::FunctionInvocation::operator&lt; </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Determines if the current object is less than the compared one. </p>

</div>
</div>
<a class="anchor" id="a39c8acbda74217791c7f4aa847c776f1"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::operator==" ref="a39c8acbda74217791c7f4aa847c776f1" args="(const FunctionInvocation &amp;rhs) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::RTShader::FunctionInvocation::operator== </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html">FunctionInvocation</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Determines if the current object is equal to the compared one. </p>

</div>
</div>
<a class="anchor" id="afc5bce23c96684eee4cba52bfe778d51"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::pushOperand" ref="afc5bce23c96684eee4cba52bfe778d51" args="(ParameterPtr parameter, Operand::OpSemantic opSemantic, int opMask=Operand::OPM_ALL, int indirectionLevel=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#afc5bce23c96684eee4cba52bfe778d51">Ogre::RTShader::FunctionInvocation::pushOperand</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">Operand::OpSemantic</a>&#160;</td>
          <td class="paramname"><em>opSemantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>opMask</em> = <code><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">Operand::OPM_ALL</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>indirectionLevel</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Push a new operand (on the end) to the function. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">parameter</td><td>A function parameter. </td></tr>
    <tr><td class="paramname">opSemantic</td><td>The in/out semantic of the parameter. </td></tr>
    <tr><td class="paramname">opMask</td><td>The field mask of the parameter. </td></tr>
    <tr><td class="paramname">indirectionLevel</td><td>The level of nesting inside brackets </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a25b62528459748e9a24cfb730a48e043"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::writeSourceCode" ref="a25b62528459748e9a24cfb730a48e043" args="(std::ostream &amp;os, const String &amp;targetLanguage) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a25b62528459748e9a24cfb730a48e043">Ogre::RTShader::FunctionInvocation::writeSourceCode</a> </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>os</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>targetLanguage</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a144ec0feff79051e2840e339f5458d9e" title="Abstract method that writes a source code to the given output stream in the target shader language...">FunctionAtom::writeSourceCode</a> </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a144ec0feff79051e2840e339f5458d9e">Ogre::RTShader::FunctionAtom</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a42c43ab09ddc59f82be80c525d38a3c6"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::mFunctionName" ref="a42c43ab09ddc59f82be80c525d38a3c6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a42c43ab09ddc59f82be80c525d38a3c6">Ogre::RTShader::FunctionInvocation::mFunctionName</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00235">235</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac336aaa5014552245bf7b1ce1fb6e761"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::mGroupExecutionOrder" ref="ac336aaa5014552245bf7b1ce1fb6e761" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#ac336aaa5014552245bf7b1ce1fb6e761">Ogre::RTShader::FunctionAtom::mGroupExecutionOrder</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00072">72</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="a452182d826bf64b754dbb220227e68a2"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::mInternalExecutionOrder" ref="a452182d826bf64b754dbb220227e68a2" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1FunctionAtom.html#a452182d826bf64b754dbb220227e68a2">Ogre::RTShader::FunctionAtom::mInternalExecutionOrder</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00073">73</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="abcff7ec674637ae18bd18a890130f975"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::mOperands" ref="abcff7ec674637ae18bd18a890130f975" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#a709fbe496a60e5c9568461c236b4fa26">OperandVector</a> <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#abcff7ec674637ae18bd18a890130f975">Ogre::RTShader::FunctionInvocation::mOperands</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00237">237</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad7a2d9fefa8e5048587b2669b5254470"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::mReturnType" ref="ad7a2d9fefa8e5048587b2669b5254470" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#ad7a2d9fefa8e5048587b2669b5254470">Ogre::RTShader::FunctionInvocation::mReturnType</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00236">236</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="aaae61702cada22f742ffd7f26d56c723"></a><!-- doxytag: member="Ogre::RTShader::FunctionInvocation::Type" ref="aaae61702cada22f742ffd7f26d56c723" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1FunctionInvocation.html#aaae61702cada22f742ffd7f26d56c723">Ogre::RTShader::FunctionInvocation::Type</a><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The type of this class. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00231">231</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:31
</p>
</body>
</html>
